#pragma once

#include "../ScriptHook/NativeFiberThread.h"
#include "../ScriptHook/ScriptingEnums.h"
#include "../ScriptHook/ScriptingTypes.h"
#include "Scripting.h"
#include "coord.h"
#include "states.h"
#include "taxiSettings.h"
#include "pedManager.h"
#include "coordManager.h"
#include <windows.h>

using namespace Scripting;

class CustomFiberThread : 
	public NativeFiberThread
{
private:
	Coord coord;
	int currentState;
	PedManager pedManager;
	CoordManager coordManager;


	Blip tarBlip;
	Blip sprayBlip;


	Object targetObject;

	int fixedMoney;
	f32 tipPercent;
	f32 tipDecrement;
	int totalMoney;
	f32 carHealth;
	int totalFares;
	u32 nextNitro;

	//timers
	u32	taxiStartTimer,
		taxiStopTimer,
		taxiNoFareTimer,
		taxiDescTimer,
		taxiCompleteTimer,
		pickThemUpTimer;

	bool displayedCredits;
	bool showCoords;
	char  ComputerName [MAX_COMPUTERNAME_LENGTH + 1];


	void SpawnCar(Scripting::eModel model);
	bool deadOrArrested() const;
	void setTextProps(u32 font,f32 wrapX,f32 wrapY, u32 state,u32 extra1,u32 extra2,u32 extra3,u32 extra4,u32 extra5) const;
	bool drivingTaxi() const;
	void checkKeys();
	void displayText(const ch *toDisp,u32 flag) const;
	void setTarget(f32 x,f32 y,f32 z);
	void setState(int s);
	void update();
	void clearTarget();
	void totalCleanUp();
	void drawTip() const;
	void updateTip();
	void displaySpray();
	void stopSpray();
	static void addMoney(int amount);
	void doBonus();
	static void save(int toSave);
	static int loadSaved();
protected:
	void RunScript();

public:
	CustomFiberThread();
};