#include "pedManager.h"
#include "taxiPed.h"
#include "../ScriptHook/ScriptingEnums.h"
#include "Scripting.h"
#include <vector>

PedManager::PedManager()
{
	maxPeds = 2;
	ped = TaxiPed();
	unwantedPeds = std::vector<Scripting::Ped>();
}

PedManager::~PedManager()
{
//	cleanUp();
}

void PedManager::update(){
	ped.update();
}
void PedManager::setState(int s){
	
	if(curState == s){
		return;
	}

	if(s == STATE_PLAYER_NOT_IN_TAXI || s == STATE_IN_TAXI_BEFORE_MISSIONS){ //not in a cab or taxi mode isn't on.
		cleanUp();
	}
	curState = s;
}

void PedManager::findPed(){
	Scripting::Ped p = Scripting::Ped();;
	ped.getPed(&p);
	if(!Scripting::DoesCharExist(p)){
		Scripting::Ped lucky;
		f32 x,y,z;
		Scripting::GetCharCoordinates(Scripting::GetPlayerPed(),&x,&y,&z);
		Scripting::GetRandomCharInAreaOffsetNoSave(x, y, z, 40.0f, 40.0f, 10.0f, &lucky);
		if(Scripting::DoesCharExist(lucky)){
			bool bad = false;

			//if(GetCharMoney(lucky)<=10) // we don't want hobos in our taxi
			//	usedPeds.push_back(lucky);

			Scripting::eModel pModel;
			Scripting::GetCharModel(lucky,&pModel);
			if(pModel == Scripting::MODEL_M_M_FATCOP_01 || pModel == Scripting::MODEL_M_M_FBI || pModel == Scripting::MODEL_M_M_FEDCO ||
				pModel == Scripting::MODEL_M_Y_COP || pModel == Scripting::MODEL_M_Y_COP_TRAFFIC)
				bad = true;
			for(int i=0;i<(int)unwantedPeds.size();i++){
				if(Scripting::DoesCharExist(unwantedPeds.at(i))){
					if(unwantedPeds.at(i) == lucky){
						bad = true;
					}
				}
			}
			if(!bad){
				ped.setPed(lucky);
			}
		}

	}
}

void PedManager::cleanUp(){
	//Scripting::Ped p;
	//ped.getPed(&p);
	//unwantedPeds.push_back(p);
	ped.cleanUp();
}
int PedManager::getState() const
{
	return ped.getState();
}
void PedManager::getPed( Scripting::Ped *ped ) const
{
	this->ped.getPed(ped);
}
void PedManager::checkPeds(){
	Scripting::Ped p = Scripting::Ped();
	ped.getPed(&p);
	if(!Scripting::DoesCharExist(p)){
		findPed();
		return;
	}
}